/**********************************************
 *                                            *
 *     DIGITAL READ-OUT FOR DIGITAL SCALE     *
 *                                            *
 *              Created by Hazie              *
 *          make-it-hazy.blogspot.com         *
 *                                            *
 **********************************************

 Before program the code,
 set fuse-bit options bellow.

  - SELFPRGEN      = None (default)
  - DWEN           = None (default)
  - EESAVE         = None (default)
  - SPI Enable     = Check (default)
  - WDTON          = None (default)
  - BODLEVEL       = Disable (default)
  - RSTDISBL       = None (default)
  - CKDIV8         = None
  - CKOUT          = None (default)
  - SUT_CKSEL      = Int. RC Osc. 8 MHz; Start-up time: 14CK + 65ms

 */

#include <avr/io.h>
#include <avr/sleep.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include "defines.h"
#include "functions.h"
#include <util/delay.h>

#define PUBLIC
#include "globals.h"

/*
  Main Loop
*/
int main(void)
{
	uint8_t *getp;		/* obt@|C^̃Rs[ */
	int8_t i;
	int32_t ro = 0;		/* f[^̓ǂݍݒl */
	uint8_t unit = UNIT_MM;
	uint8_t sign = 0;
	uint8_t is_sign_placed = 0;
	uint8_t comdp = COM_DP_MM; /* _uʒu(COMԍ) */
	uint8_t unit_key_pushed = 0;
	uint8_t zero_pulse = 0;
	uint8_t zero_key_pushed = 0;

	init_io();
	timer0_init();
	timer1_init();
	sei();
	lamptest();		/* X^[gAbṽM~bN */

	Rbufp = Rbuf;		/* obt@|C^擪 */
	init_int1();		/* XP[̓͊Jn */

	set_sleep_mode(SLEEP_MODE_IDLE);
	while(1) {
		sleep_mode();

		//-----------------------------------------------------
		// ̊ԃX[v(Idle Mode)
		//
		// Timer0܂Int1荞݂ŕA
		//-----------------------------------------------------

		if (Updated) {	/* Pos_relXVꂽƂvZ */
			if (zero_pulse > 0) { /* [NAMoĂԂ */
				ro = 0;	/* Iɒl[Ƃi\Ȃ߁j */
			} else {
				cli();
				getp = (uint8_t *)Rbuf; 
				sei();

				getp += 24;
				for (i = 0; i < 24; i++) {
					if (*getp++ & _BV(SCALE_DA_BIT)) { /* f[^͔]Ă炵i̔]猳̂܂܁j */
						ro |= 0xff000000; /* gbit23 */
						ro >>= 1;
					} else {
						ro &= 0x00ffffff;
						ro >>= 1;
					}
				}
			}

			Updated = 0;

			for (i = 0; i < 6; ++i) {
				Segment[i] = LED_BLANK;
			}

			// ␔𕄍ƐΒlɕ
			sign = (ro < 0);
			if (sign)
				ro = -ro;
			is_sign_placed = 0;
			// Pʂϊ
			if (unit == UNIT_MM)
				ro = ro * CONV_MUL_MM / CONV_DIV_MM;
			else
				ro = ro * CONV_MUL_INCH / CONV_DIV_INCH;

			for (i = 5; i >= 0; --i) { /* ̌ */
				if (ro == 0 && i < comdp) {
					// ƃ[TvX̏
					if (sign && !is_sign_placed)
						Segment[i] = LED_MINUS;
					else
						Segment[i] = LED_BLANK;
					is_sign_placed = 1;
				} else {
					// e̐\i[̌"0"\j
					Segment[i] = ro % 10;
				}
				ro /= 10;
			}
			// __
			Segment[comdp] |= 0x80;
		}

		// L[̌o
		if (Key[KEY_ZERO_BIT] > KEY_DEBOUNCE) {/* "ZERO"L[o */
			if (!zero_key_pushed) {	/* ĂԌJԂȂ悤 */
				scale_zero_on(); /* [NAM𑗂 */
				zero_pulse = ZERO_DURATION;
				zero_key_pushed = 1;
			}
		} else 
			zero_key_pushed = 0;

		if (zero_pulse > 0) /* [NAMɈ̃pX^ */
			--zero_pulse;
		else
			scale_zero_off(); /* Ԃ[NAM~ */

		if (Key[KEY_UNIT_BIT] > KEY_DEBOUNCE) { // "UNIT"L[o
			if (!unit_key_pushed) {	/* ĂԌJԂȂ悤 */
				// ͒PʂƏ_ʒu؂ւ
				if (unit == UNIT_MM) {
					unit = UNIT_INCH;
					comdp = COM_DP_INCH;
				} else {
					unit = UNIT_MM;
					comdp = COM_DP_MM;
				}
				unit_key_pushed = 1;
			}
		} else
			unit_key_pushed = 0;
	}
	return 0;
}

