#include "defines.h"
#include <avr/io.h>
#include <avr/interrupt.h>
#include "functions.h"

void timer0_init(void)
{
#if defined (__AVR_AT90S2313__)
	TCNT0 = 0xff - TM0_COUNTS;
	TIMSK = _BV(TOV0);	/* timer0I[o[t[荞݋ */
	TCCR0 = 0b100 << CS00;	/* NbN256 */
#else  /* defined (__AVR_ATtiny2313__) */
	TCNT0 = 0;
	OCR0A = TM0_COUNTS;
	TIMSK = _BV(OCIE0A);	/* timer0rvA荞݋ */
	TCCR0A = 0b10 << WGM00;	/* CTC */
	TCCR0B = 0b100 << CS00;	/* NbN256 */
#endif
}

void timer1_init(void)
{
	TCNT1 = 0;
	OCR1A = UPDATE_IVL;	/* f[^̐؂ځXVԊuLԁi0.25sȏj */
#if defined (__AVR_AT90S2313__)
	TCCR1A = _BV(CTC1);	/* CTC */
	TCCR1B = 0b100 << CS00;	/* NbN256 */
#else  /* defined (__AVR_ATtiny2313__) */
	TCCR1A = (0b00 << WGM10);	/* CTC */
	TCCR1B = (0b01 << WGM12) | (0b100 << CS10);	/* NbN256 */
#endif
	TIMSK |= _BV(OCIE1A);	/* timer1rvA荞݋ */
}

